
struct GadePara
{
   double p;
   double mp;
   double Fm[2];
   double CRm[2];
   double Mc[2];
   double c;
   double *F[2];
   double *CR[2];
   long double BestFitness;
   int np;
   int *flag[2];
   int *index;
   long double *DiffFitness;
};
typedef struct GadePara GadePara;

struct GadeSetting
{
   int Dimension;
   int Population;
   double SAfactor;
   int MaxFEs;
   int StartRun;
   int EndRun;
   int StartFunction;
   int EndFunction;
};
typedef struct GadeSetting GadeSetting;

void gadeInit(int func_num, GadeSetting gade, GadePara *para, Individual *pop);
void gadeSetParameters(GadePara *para);
void gadeMutation(int np, GadePara para, Individual *pop, Individual *vpop);
void gadeCrossover(int, GadePara, Individual *, Individual *, Individual *);
void gadeSelection(int np, Individual *pop, Individual *upop, GadePara *para);
void gadeAdaptParameters(GadePara *para);
long double gadeBestFitness(int np, Individual *pop);
int gadeBestIndex(int np, int lower, int upper, int *r, Individual *pop);
void gadeFinalize(void);

