
function tracemean(fstart, fend, dim)

runs = 25;
fnum = fend-fstart+1;
   
fbest   = [];
fmedian = [];
fworst  = [];
fmean   = [];
fstd    = [];

for k = fstart:fend
   results = [];
   
   for i = 1:runs
      filename = sprintf('result/fitness_f%02dr%02dd%02d.txt', k, i, dim);
      res = load(filename);
      results = [results; res(end)];
   end
   
   fbest   = [fbest; min(results)];
   fmedian = [fmedian; median(results)];
   fworst  = [fworst; max(results)];
   fmean   = [fmean; mean(results)];
   fstd    = [fstd; std(results)];
end

fprintf(1, 'best\n');
for k = 1:fnum
   fprintf(1, '%.2e\n', fbest(k));
end
fprintf(1, '\n');

fprintf(1, 'median\n');
for k = 1:fnum
   fprintf(1, '%.2e\n', fmedian(k));
end
fprintf(1, '\n');

fprintf(1, 'worst\n');
for k = 1:fnum
   fprintf(1, '%.2e\n', fworst(k));
end
fprintf(1, '\n');

fprintf(1, 'mean\n');
for k = 1:fnum
   fprintf(1, '%.2e\n', fmean(k));
end
fprintf(1, '\n');

